/**
 * Copyright (c) 2009 - Lehigh University. Bethlehem, PA, USA.
 * All rights reserved.
 * This source code is a part of MARCHES Project. 
 * 
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice, the following
 * two paragraphs, and the author attribution appear in all copies of this
 * software.
 *
 * IN NO EVENT SHALL LEHIGH UNIVERSITY BE LIABLE TO ANY PARTY FOR DIRECT, 
 * INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF LEHIGH
 * UNIVERSITY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *	
 * LEHIGH UNIVERSITY SPECIFICALLY DISCLAIMS ANY WARRANTIES, INCLUDING, BUT NOT 
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A 
 * PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, 
 * AND LEHIGH UNIVERSITY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, 
 * SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
 **/

// modsDlg.cpp : implementation file
//

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Elearning.Teacher
{
    public partial class FormPref : Form
    {
        public int m_interval, m_quality;

        public FormPref()
        {
            InitializeComponent();
        }

        private void buttonOK_Click(object sender, EventArgs e)
        {
            if (textBoxIntv.Text.Length == 0 || textBoxQuat.Text.Length == 0)
            {
                MessageBox.Show("You must input the values.\n");
                return;
            }

            m_interval = System.Convert.ToInt16(textBoxIntv.Text, 10);
            m_quality = System.Convert.ToInt16(textBoxQuat.Text, 10);

            if (m_interval < 0)
            {
                MessageBox.Show("interval must be larger than zero.");
                return;
            }
            if (m_quality < 1 || m_quality > 100)
            {
                MessageBox.Show("the quality must between 0 and 100.");
                return;
            }
            this.DialogResult = DialogResult.OK;
            this.Close();
        }

        private void FormPref_Load(object sender, EventArgs e)
        {
            textBoxIntv.Text = m_interval.ToString();
            textBoxQuat.Text = m_quality.ToString();
        }
    }
}