/**
 * Copyright (c) 2009 - Lehigh University. Bethlehem, PA, USA.
 * All rights reserved.
 * This source code is a part of MARCHES Project. 
 * 
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice, the following
 * two paragraphs, and the author attribution appear in all copies of this
 * software.
 *
 * IN NO EVENT SHALL LEHIGH UNIVERSITY BE LIABLE TO ANY PARTY FOR DIRECT, 
 * INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF LEHIGH
 * UNIVERSITY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *	
 * LEHIGH UNIVERSITY SPECIFICALLY DISCLAIMS ANY WARRANTIES, INCLUDING, BUT NOT 
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A 
 * PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, 
 * AND LEHIGH UNIVERSITY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, 
 * SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
 **/

// modsDlg.cpp : implementation file
//

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Net;
using Elearning.MySocket;

namespace Elearning.Teacher
{
    public partial class FormStart : Form
    {
        public int portVideo, portAudio, portChbox, portSlide;
        public String strName;

        public FormStart()
        {
            InitializeComponent();
        }

        private void FormStart_Load(object sender, EventArgs e)
        {
            String strHostName = Dns.GetHostName();
            IPHostEntry ipEntry = Dns.GetHostEntry(strHostName);
            IPAddress[] addr = ipEntry.AddressList;

            if (addr.Length > 0) textBoxIP.Text = addr[0].ToString();

            for (int i = 1; i < addr.Length; i++)
            {
                textBoxIP.Text = textBoxIP.Text + "; " + addr[i].ToString();
            }

            this.textBoxPortVideo.Text = UDPServer.PORTVIDEO.ToString();
            this.textBoxPortAudio.Text = UDPServer.PORTAUDIO.ToString();
            this.textBoxPortChBox.Text = TCPServer.PORTCHBOX.ToString();
            this.textBoxPortSlide.Text = UDPServer.PORTSLIDE.ToString();

        }

        private void checkBoxDef_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBoxDef.Checked)
            {
                textBoxPortVideo.Text = UDPServer.PORTVIDEO.ToString();
                textBoxPortAudio.Text = UDPServer.PORTAUDIO.ToString();
                textBoxPortChBox.Text = TCPServer.PORTCHBOX.ToString();
                textBoxPortSlide.Text = UDPServer.PORTSLIDE.ToString();
            }
            textBoxPortVideo.ReadOnly = checkBoxDef.Checked;
            textBoxPortAudio.ReadOnly = checkBoxDef.Checked;
            textBoxPortChBox.ReadOnly = checkBoxDef.Checked;
            textBoxPortSlide.ReadOnly = checkBoxDef.Checked;
        }

        private void buttonOK_Click(object sender, EventArgs e)
        {
            if (textBoxName.Text.Length == 0)
            {
                MessageBox.Show("User name required to connect to the Server\n");
                return;
            }
            strName = textBoxName.Text;

            portVideo = System.Convert.ToInt16(textBoxPortVideo.Text, 10);
            portAudio = System.Convert.ToInt16(textBoxPortAudio.Text, 10);
            portChbox = System.Convert.ToInt16(textBoxPortChBox.Text, 10);
            portSlide = System.Convert.ToInt16(textBoxPortSlide.Text, 10);

            this.DialogResult = DialogResult.OK;
            this.Close();
        }
    }
}