/**
 * Copyright (c) 2009 - Lehigh University. Bethlehem, PA, USA.
 * All rights reserved.
 * This source code is a part of MARCHES Project. 
 * 
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice, the following
 * two paragraphs, and the author attribution appear in all copies of this
 * software.
 *
 * IN NO EVENT SHALL LEHIGH UNIVERSITY BE LIABLE TO ANY PARTY FOR DIRECT, 
 * INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF LEHIGH
 * UNIVERSITY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *	
 * LEHIGH UNIVERSITY SPECIFICALLY DISCLAIMS ANY WARRANTIES, INCLUDING, BUT NOT 
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A 
 * PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, 
 * AND LEHIGH UNIVERSITY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, 
 * SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
 **/

// modsDlg.cpp : implementation file
//

using System;
using System.Collections.Generic;
using System.Text;
using System.Net;
using System.Net.Sockets;
using System.Drawing;
using System.Windows.Forms;
using System.Collections;

namespace Elearning.Teacher
{
    #region classes declare

    public class StudentRecord
    {
        public IPEndPoint m_endPointVideo = null;
        public IPEndPoint m_endPointAudio = null;
        public IPEndPoint m_endPointSlide = null;
        public Socket m_sockChbox = null;
        public PictureBox m_picBox = null;
        public String m_strName;
    }


    public class StudentTable
    {
        private Hashtable m_studentClients;
        private String m_strActiveKey;
        private Socket sockVideo, sockSlide;

        public StudentTable(int n)
        {
            m_studentClients = new Hashtable(n);
            m_strActiveKey = "All";
            
            sockVideo = new Socket(AddressFamily.InterNetwork, SocketType.Dgram, ProtocolType.Udp);
            sockSlide = new Socket(AddressFamily.InterNetwork, SocketType.Dgram, ProtocolType.Udp);
        }

        public void Close()
        {
            IDictionaryEnumerator _enumerator = m_studentClients.GetEnumerator();
            while (_enumerator.MoveNext())
            {
                if (((StudentRecord)(_enumerator.Value)).m_sockChbox != null)
                {
                    ((StudentRecord)(_enumerator.Value)).m_sockChbox.Close();
                    ((StudentRecord)(_enumerator.Value)).m_sockChbox = null;
                }
            }
            m_studentClients.Clear();
        }

        public StudentRecord this[String key] { 
            get
            {
                return (StudentRecord)(m_studentClients[key]);
            }
            set
            {
                m_studentClients[key] = value; 
            }
        }

        public bool ContainsKey(String key)
        {
            return m_studentClients.ContainsKey(key);
        }

        public void Add(String key, StudentRecord record)
        {
            m_studentClients.Add(key, record);
        }

        public void Remove(String key)
        {
            this[key].m_sockChbox.Close();
            m_studentClients.Remove(key);
        }

        public void SendMsg(byte[] data)
        {
            if (m_strActiveKey == "All")
            {
                IDictionaryEnumerator _enumerator = m_studentClients.GetEnumerator();
                while (_enumerator.MoveNext())
                {
                    if (((StudentRecord)(_enumerator.Value)).m_sockChbox != null)
                    {
                        if (((StudentRecord)(_enumerator.Value)).m_sockChbox.Connected)
                        {
                            ((StudentRecord)(_enumerator.Value)).m_sockChbox.Send(data);
                        }
                    }
                }
            }
            else
            {
                ((StudentRecord)(m_studentClients[m_strActiveKey])).m_sockChbox.Send(data);
            }

        }

        public void SendVideo(byte[] data)
        {
            bool bUseUnicast = true;

            if (bUseUnicast)
            {
                try
                {
                    IDictionaryEnumerator _enumerator = m_studentClients.GetEnumerator();
                    while (_enumerator.MoveNext())
                    {
                        EndPoint stdEndPoint = ((StudentRecord)(_enumerator.Value)).m_endPointVideo;
                        if (stdEndPoint != null)
                        {
                            sockVideo.SendTo(data, stdEndPoint);
                        }
                    }
                }
                catch (SocketException se)
                {
                    MessageBox.Show(se.Message);
                }
            }
        }

        public void SendSlide(byte[] data)
        {
            bool bUseUnicast = true;

            if (bUseUnicast)
            {
                try
                {
                    IDictionaryEnumerator _enumerator = m_studentClients.GetEnumerator();
                    while (_enumerator.MoveNext())
                    {
                        EndPoint stdEndPoint = ((StudentRecord)(_enumerator.Value)).m_endPointSlide;
                        if (stdEndPoint != null)
                        {
                            sockSlide.SendTo(data, stdEndPoint);
                        }
                    }
                }
                catch (SocketException se)
                {
                    MessageBox.Show(se.Message);
                }
            }
        }

        public String m_strActiveClientIP
        {
            get
            {
                return m_strActiveKey;
            }
            set
            {
                if (m_strActiveKey != "All") 
                    this[m_strActiveKey].m_picBox.BorderStyle = BorderStyle.FixedSingle;
                if (value != "All") 
                    this[value].m_picBox.BorderStyle = BorderStyle.Fixed3D;
                m_strActiveKey = value;

            }
        }

    }

    #endregion


}
