/**
 * Copyright (c) 2009 - Lehigh University. Bethlehem, PA, USA.
 * All rights reserved.
 * This source code is a part of MARCHES Project. 
 * 
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice, the following
 * two paragraphs, and the author attribution appear in all copies of this
 * software.
 *
 * IN NO EVENT SHALL LEHIGH UNIVERSITY BE LIABLE TO ANY PARTY FOR DIRECT, 
 * INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF LEHIGH
 * UNIVERSITY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *	
 * LEHIGH UNIVERSITY SPECIFICALLY DISCLAIMS ANY WARRANTIES, INCLUDING, BUT NOT 
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A 
 * PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, 
 * AND LEHIGH UNIVERSITY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, 
 * SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
 **/

// modsDlg.cpp : implementation file
//

using System;
using System.Drawing;

/// <summary>
/// Summary description for Class1
/// </summary>
/// 
namespace Masslets
{
    abstract public class Masslet
    {
        public Masslet()
        {
            //
            // TODO: Add constructor logic here
            //

        }

        abstract public bool Start();
        abstract public bool Stop();
    }

    public delegate void MassletDataReadyEventHandler(object sender, MassletEventArgs e);

    public class MassletEventArgs : EventArgs
    {
        private byte[] data;
        public MassletEventArgs(byte[] dt)
        {
            data = dt;
        }
        public byte[] mData
        {
            get
            {
                return data;
            }
        }
    }

    public delegate void ImageRefReadyEventHandler(object sender, ImageEventArgs e);

    public class ImageEventArgs : EventArgs
    {
        private Image image;
        public ImageEventArgs(Image im)
        {
            image = im;
        }
        public Image mImage
        {
            get
            {
                return image;
            }
        }
    }
}
