/**
 * Copyright (c) 2009 - Lehigh University. Bethlehem, PA, USA.
 * All rights reserved.
 * This source code is a part of MARCHES Project. 
 * 
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice, the following
 * two paragraphs, and the author attribution appear in all copies of this
 * software.
 *
 * IN NO EVENT SHALL LEHIGH UNIVERSITY BE LIABLE TO ANY PARTY FOR DIRECT, 
 * INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF LEHIGH
 * UNIVERSITY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *	
 * LEHIGH UNIVERSITY SPECIFICALLY DISCLAIMS ANY WARRANTIES, INCLUDING, BUT NOT 
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A 
 * PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, 
 * AND LEHIGH UNIVERSITY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, 
 * SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
 **/

// modsDlg.cpp : implementation file
//

using System;
using System.Collections.Generic;
using System.Text;
using System.Threading;

namespace MassTools.EnvironmentAwareness.SensorReader
{
    public class SerialPortReader : MassTool
    {
        public event MassToolDataReadyEventHandler DataReadyEvent;

        Thread m_toolThread = null;
        public SerialPortReader()
        {
            m_toolThread = new Thread(new ThreadStart(MeasureFunc));
        }

        public override bool Start()
        {
            m_toolThread.Start();
            return true;
        }

        public override bool Stop()
        {
            m_toolThread.Abort();
            return true;
        }

        public void AddSubscriber(MassToolDataReadyEventHandler handler)
        {
            DataReadyEvent += handler;
        }

        public void MeasureFunc()
        {
        }

        public const int STOPBITS_1 = 1;
        public const int STOPBITS_2 = 2;
        public const int STOPBITS_1_5 = 3;

        /*
        public static const int FLOWCONTROL_NONE = 0;
        public static const int FLOWCONTROL_RTSCTS_IN = 1;
        public static const int FLOWCONTROL_RTSCTS_OUT = 2;
        public static const int FLOWCONTROL_XONXOFF_IN = 4;
        public static const int FLOWCONTROL_XONXOFF_OUT = 8;
        */

        public byte[] getInputStream()
        {
            return null;
        }
        public byte[] getOutputStream()
        {
            return null;
        }

        public bool open()
        {
            return true;
        }
        public void close()
        {

        }
        public void finalize()
        {
        }

        public void setSerialPortParams(int baudrate, int dataBits, int stopBits, bool parity)
        {
        }
        public int getBaudRate()
        {
            return 0;
        }
        public int getDataBits()
        {
            return 0;
        }
        public int getStopBits()
        {
            return 0;
        }
        public bool getParity()
        {
            return true;
        }

        public void sendBreak(int millis)
        {
        }

        /*
        public void setFlowControlMode( int flowcontrol )
          throws UnsupportedCommOperationException;
        public int getFlowControlMode();
        */

        public void setDTR(bool dtr)
        {
        }
        public void setRTS(bool rts)
        {
        }
        public bool isDTR()
        {
            return true;
        }
        public bool isRTS()
        {
            return true;
        }
        public bool isCTS()
        {
            return true;
        }
        public bool isDSR()
        {
            return true;
        }
        public bool isRI()
        {
            return true;
        }
        public bool isCD()
        {
            return true;
        }

        public void notifyOn(int serialEvent, bool enable)
        {
        }

    }
}
